## papi 7.0.1

=== src/ftests/Makefile ===
# File: ftests/Makefile

include Makefile.target

INCLUDE = -I../testlib -I. -I..
FFLAGS	= $(CFLAGS) -ffixed-line-length-132
testlibdir=../testlib
TESTLIB= $(testlibdir)/libtestlib.a
DOLOOPS= $(testlibdir)/do_loops.o

ifneq ($(F77),)
include Makefile.recipies

install: default
	@echo "Fortran tests (DATADIR) being installed in: \"$(DATADIR)\""; 
	-mkdir -p $(DATADIR)/ftests
	-chmod go+rx $(DATADIR)
	-chmod go+rx $(DATADIR)/ftests
	-find . -perm -100 -type f -exec cp {} $(DATADIR)/ftests \;
	-chmod go+rx $(DATADIR)/ftests/*
	-find . -name "*.[Ffh]" -type f -exec cp {} $(DATADIR)/ftests \;
	-cp Makefile.target $(DATADIR)/ftests/Makefile
	-cat Makefile.recipies >> $(DATADIR)/ftests/Makefile

else
all:
	@echo "Install Fortran compiler to build and run Fortran tests"

install:
	@echo "No Fortran tests to install."

clean:

distclean clobber:
	rm -f Makefile.target
endif

=== src/components/cuda/sampling/Makefile ===
# Set defaults if these environment variables are not set yet.
PAPI_CUDA_ROOT ?= /opt/cuda
PAPI_CUDA_INC ?= $(PAPI_CUDA_ROOT)/include
PAPI_CUPTI_INC ?= $(PAPI_CUDA_ROOT)/extras/CUPTI/include
PAPI_CUDA_LIBS ?= $(PAPI_CUDA_ROOT)/lib64
PAPI_CUDA_STUBS ?= $(PAPI_CUDA_ROOT)/lib64/stubs
PAPI_CUPTI_LIBS ?= $(PAPI_CUDA_ROOT)/extras/CUPTI/lib64
CFG = -I$(PAPI_CUDA_INC)  -I$(PAPI_CUPTI_INC)
LDG = -L$(PAPI_CUDA_LIBS) -L$(PAPI_CUDA_STUBS)  -L$(PAPI_CUPTI_LIBS)
NVCC = $(PAPI_CUDA_ROOT)/bin/nvcc $(NVPPC64LEFLAGS)

all:
	@make lib
	@make papi_sampling
	@make sample
	@make cpy

lib: activity.c
	@gcc -fPIC -shared -o libactivity.so  $(CFG) $(LDG) activity.c -lcuda -lcupti

papi_sampling: gpu_activity.c
	@echo 'char* ld_prld="LD_PRELOAD='`pwd`'/sampling/libactivity.so";' > path.h
	@gcc -I. gpu_activity.c -o ../../../utils/papi_sampling_cuda

sample: test/matmul.cu
	@$(NVCC) test/matmul.cu $(CFG) $(LDG) -o test/matmul -lcuda 

cpy:
	cp ../../../utils/papi_sampling_cuda  test

clean:
	rm libactivity.so ../../../utils/papi_sampling_cuda test/matmul test/sass* test/papi_sampling_cuda

=== src/components/cuda/tests/Makefile ===
NAME=cuda
include ../../Makefile_comp_tests.target

PAPI_CUDA_ROOT ?= /opt/cuda
PAPI_CUPTI_ROOT ?= $(PAPI_CUDA_ROOT)/extras/CUPTI
CUDRV_DIR ?= $(PAPI_CUDA_ROOT)

TESTS = cupti_multi_kernel_launch_monitoring HelloWorld simpleMultiGPU simpleMultiGPU_no_counters
cuda_tests: $(TESTS) 

PAPI_CUDA_ROOT ?= $(CUDA_PATH)
NVCC = $(PAPI_CUDA_ROOT)/bin/nvcc 
NVCFLAGS = -g -ccbin='$(CC)' $(NVPPC64LEFLAGS)
INCLUDE += -I$(PAPI_CUDA_ROOT)/include -I$(PAPI_CUPTI_ROOT)/include 
CUDALIBS = -L$(CUDRV_DIR)/lib64 -L$(PAPI_CUDA_ROOT)/lib64 -L$(PAPI_CUDA_ROOT)/lib64/stubs -L$(PAPI_CUPTI_ROOT)/lib64 -lcudart -lcupti -lcuda 
PAPILIB += -L../../../libpfm4/lib -lpfm
default: $(TESTS)

%.o:%.cu
	$(NVCC) $(INCLUDE) $(NVCFLAGS) -c -o $@ $<

%.mac:%.cu
	$(NVCC) $(INCLUDE) $(NVCFLAGS) -E -c -o $@ $<

cupti_multi_kernel_launch_monitoring: cupti_multi_kernel_launch_monitoring.o $(UTILOBJS)
	$(NVCC) $(NVCFLAGS) -o cupti_multi_kernel_launch_monitoring cupti_multi_kernel_launch_monitoring.o $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

test_multipass_event_fail: test_multipass_event_fail.c
	$(NVCC) $(NVCFLAGS) -o test_multipass_event_fail test_multipass_event_fail.c $(INCLUDE) $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

HelloWorld_CUPTI11: HelloWorld_CUPTI11.o $(UTILOBJS)
	$(NVCC) $(NVCFLAGS) -o HelloWorld_CUPTI11 HelloWorld_CUPTI11.o $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

HelloWorld: HelloWorld.o $(UTILOBJS)
	$(NVCC) $(NVCFLAGS) -o HelloWorld HelloWorld.o $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

HelloWorld_NP_Ctx: HelloWorld_NP_Ctx.o $(UTILOBJS)
	$(NVCC) $(NVCFLAGS) -o HelloWorld_NP_Ctx HelloWorld_NP_Ctx.o $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

simpleMultiGPU: simpleMultiGPU.cu $(UTILOBJS)
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DPAPI -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

simpleMultiGPU_CUPTI11: simpleMultiGPU_CUPTI11.cu $(UTILOBJS)
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DPAPI -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

simpleMultiGPU_no_counters: simpleMultiGPU.cu $(UTILOBJS)
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DNO_COUNTERS -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

simpleMultiGPU_cupti_only: simpleMultiGPU.cu $(UTILOBJS)
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DCUPTI_ONLY -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

nvlink_bandwidth: nvlink_bandwidth.cu $(UTILOBJS)
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DPAPI -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

nvlink_bw_plus: nvlink_bw_plus.cu $(UTILOBJS)
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DPAPI -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

cuda_event_only_test: cuda_event_only_test.cu $(UTILOBJS)
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DPAPI -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

cudaTest_cupti_only: cudaTest_cupti_only.cu $(UTILOBJS)
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DPAPI -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

likeComp_cupti_only: likeComp_cupti_only.cu $(UTILOBJS)
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DPAPI -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

nvlink_all: nvlink_all.cu $(UTILOBJS)
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DPAPI -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

nvlink_bandwidth_cupti_only: nvlink_bandwidth_cupti_only.cu $(UTILOBJS)
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DPAPI -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

# The following program is taken from the cuda sample directory; /sw/peak/cuda/9.2.148/samples/1_Utilities/
nvidia_sample_bw_test: nvidia_sample_bw_test.cu $(UTILOBJS)
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -I./sample_inc -DPAPI -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

# The following program is taken from the cuda sample directory; /sw/peak/cuda/9.2.148/samples/1_Utilities/
p2pBandwidthLatencyTest: p2pBandwidthLatencyTest.cu $(UTILOBJS)
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -I./sample_inc -DPAPI -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

clean:
	rm -f $(TESTS) *.o cuda_ld_preload_example.so nvlink_bandwidth nvlink_all


# Extra example to show LD_PRELOAD can be used to insert PAPI CUDA into a pre-existing binary
cuda_ld_preload_example.so: simpleMultiGPU_no_counters cuda_ld_preload_example.c
	gcc -Wall -fPIC -shared -o cuda_ld_preload_example.so $(LDFLAGS) $(INCLUDE) cuda_ld_preload_example.c ../../../libpapi.so

run: 
	( cd ~/icl/papi/papi/src/ && make )
	( make HelloWorld )
	./HelloWorld
	( cd ~/icl/papi/papi/src/ && make )
	( make simpleMultiGPU )
	./simpleMultiGPU

=== src/components/rocm/tests/Makefile ===
NAME = rocm
include ../../Makefile_comp_tests.target
PAPI_ROCM_ROOT ?= /opt/rocm

CC       = $(PAPI_ROCM_ROOT)/hip/bin/hipcc
CXX      = $(PAPI_ROCM_ROOT)/hip/bin/hipcc
CPPFLAGS+= -I$(PAPI_ROCM_ROOT)/include          \
           -I$(PAPI_ROCM_ROOT)/include/hip      \
           -I$(PAPI_ROCM_ROOT)/include/hsa      \
           -I$(PAPI_ROCM_ROOT)/hip/include/hip  \
           -I$(PAPI_ROCM_ROOT)/hsa/include/hsa  \
           $(INCLUDE)
LDFLAGS += $(PAPILIB) $(TESTLIB) -fopenmp
CXXFLAGS = -g -O0 -fopenmp

rocm_tests: ALL

ALL: sample_single_kernel_monitoring       \
     sample_single_thread_monitoring       \
     sample_multi_kernel_monitoring        \
     sample_multi_thread_monitoring        \
     sample_overflow_monitoring            \
     intercept_single_kernel_monitoring    \
     intercept_single_thread_monitoring    \
     intercept_multi_kernel_monitoring     \
     intercept_multi_thread_monitoring     \
     hl_sample_single_kernel_monitoring    \
     hl_sample_single_thread_monitoring    \
     hl_intercept_single_kernel_monitoring \
     hl_intercept_single_thread_monitoring \
     hl_intercept_multi_thread_monitoring

sample_single_kernel_monitoring: sample_single_kernel_monitoring.o matmul.o
sample_single_thread_monitoring: sample_single_thread_monitoring.o single_thread_monitoring.o matmul.o
sample_multi_thread_monitoring: sample_multi_thread_monitoring.o multi_thread_monitoring.o matmul.o
sample_multi_kernel_monitoring: sample_multi_kernel_monitoring.o multi_kernel_monitoring.o matmul.o
sample_overflow_monitoring: sample_overflow_monitoring.o matmul.o
intercept_single_kernel_monitoring: intercept_single_kernel_monitoring.o matmul.o
intercept_single_thread_monitoring: intercept_single_thread_monitoring.o single_thread_monitoring.o matmul.o
intercept_multi_thread_monitoring: intercept_multi_thread_monitoring.o multi_thread_monitoring.o matmul.o
intercept_multi_kernel_monitoring: intercept_multi_kernel_monitoring.o multi_kernel_monitoring.o matmul.o
hl_sample_single_kernel_monitoring: hl_sample_single_kernel_monitoring.o matmul.o
hl_sample_single_thread_monitoring: hl_sample_single_thread_monitoring.o matmul.o
hl_intercept_single_kernel_monitoring: hl_intercept_single_kernel_monitoring.o matmul.o
hl_intercept_single_thread_monitoring: hl_intercept_single_thread_monitoring.o matmul.o
hl_intercept_multi_thread_monitoring: hl_intercept_multi_thread_monitoring.o matmul.o

clean:
	rm -f sample_single_thread_monitoring
	rm -f sample_single_kernel_monitoring
	rm -f sample_multi_kernel_monitoring
	rm -f sample_multi_thread_monitoring
	rm -f sample_overflow_monitoring
	rm -f intercept_single_thread_monitoring
	rm -f intercept_single_kernel_monitoring
	rm -f intercept_multi_kernel_monitoring
	rm -f intercept_multi_thread_monitoring
	rm -f hl_sample_single_kernel_monitoring
	rm -f hl_sample_single_thread_monitoring
	rm -f hl_intercept_single_kernel_monitoring
	rm -f hl_intercept_single_thread_monitoring
	rm -f hl_intercept_multi_thread_monitoring
	rm -f *.o

=== src/components/sde/tests/Makefile ===
NAME=sde
include ../../Makefile_comp_tests.target
INCLUDE += -I$(datadir)/sde_lib -I..
ifeq ($(notdir $(F77)),gfortran)
	FFLAGS +=-ffree-form -ffree-line-length-none
else ifeq ($(notdir $(F77)),flang)
	FFLAGS +=-ffree-form
else
	FFLAGS +=-free
endif
FFLAGS +=-g
CFLAGS +=-g
CXXFLAGS +=-g -std=c++11

ifeq ($(BUILD_LIBSDE_SHARED),yes)
	LDFLAGS += -Llib -L$(datadir) -L$(datadir)/libpfm4/lib -lpapi -lpfm -lsde
	LIBSDE=yes
else ifeq ($(BUILD_LIBSDE_STATIC),yes)
	LDFLAGS += -Llib $(datadir)/libsde.a -lpapi
	LIBSDE=yes
endif

SDE_F08_API=../sde_F.F90

ifeq ($(LIBSDE),yes)
	TESTS = Minimal_Test Minimal_Test++ Simple_Test Simple2_Test Simple2_NoPAPI_Test Simple2_Test++ Recorder_Test Recorder_Test++ Created_Counter_Test Created_Counter_Test++ Overflow_Test Counting_Set_Simple_Test Counting_Set_MemLeak_Test Counting_Set_Simple_Test++ Counting_Set_MemLeak_Test++ sde_test_f08
endif
ifeq ($(BUILD_LIBSDE_STATIC),yes)
	TESTS += Overflow_Static_Test
endif


sde_tests: $(TESTS)

################################################################################
## Minimal test
prfx=Minimal

Minimal_Test: $(prfx)/Minimal_Test.c
	$(CC) $< -o $@ $(INCLUDE) $(CFLAGS) $(UTILOBJS) $(LDFLAGS)

Minimal_Test++: $(prfx)/Minimal_Test++.cpp
	$(CXX) $< -o $@ $(INCLUDE) $(CXXFLAGS) $(UTILOBJS) $(LDFLAGS)

################################################################################
## Simple test
prfx=Simple

libSimple.so: $(prfx)/Simple_Lib.c
	$(CC) -shared -Wall -fPIC $(CFLAGS) $(INCLUDE) -o lib/$@ $^

Simple_Test: $(prfx)/Simple_Driver.c libSimple.so
	$(CC) $< -o $@ $(INCLUDE) $(CFLAGS) $(UTILOBJS) -lSimple $(LDFLAGS) -lm

################################################################################
## Simple2 test
prfx=Simple2

libSimple2.so: $(prfx)/Simple2_Lib.c
	$(CC) -shared -Wall -fPIC $(CFLAGS) $(INCLUDE) -o lib/$@ $^

Simple2_Test: $(prfx)/Simple2_Driver.c libSimple2.so
	$(CC) $< -o $@ $(INCLUDE) $(CFLAGS) $(UTILOBJS) -lSimple2 $(LDFLAGS) -lm

Simple2_NoPAPI_Test: $(prfx)/Simple2_NoPAPI_Driver.c libSimple2.so
	$(CC) $< -o $@ $(INCLUDE) $(CFLAGS) -Llib -lSimple2 -L$(datadir) -lsde -lm -ldl

libSimple2++.so: $(prfx)/Simple2_Lib++.cpp
	$(CXX) -shared -Wall -fPIC $(CXXFLAGS) $(INCLUDE) -o lib/$@ $^

Simple2_Test++: $(prfx)/Simple2_Driver++.cpp libSimple2++.so
	$(CXX) $< -o $@ $(INCLUDE) $(CXXFLAGS) $(UTILOBJS) -lSimple2++ $(LDFLAGS) -lm

################################################################################
## Recorder test
prfx=Recorder

libRecorder.so: $(prfx)/Lib_With_Recorder.c
	$(CC) -shared -Wall -fPIC $(CFLAGS) $(INCLUDE) -o lib/$@ $^

Recorder_Test: $(prfx)/Recorder_Driver.c libRecorder.so
	$(CC) $< -o $@ $(INCLUDE) $(CFLAGS) $(UTILOBJS) -lRecorder $(LDFLAGS) -lm

libRecorder++.so: $(prfx)/Lib_With_Recorder++.cpp
	$(CXX) -shared -Wall -fPIC $(CXXFLAGS) $(INCLUDE) -o lib/$@ $^

Recorder_Test++: $(prfx)/Recorder_Driver++.cpp libRecorder++.so
	$(CXX) $< -o $@ $(INCLUDE) $(CXXFLAGS) $(UTILOBJS) -lRecorder++ $(LDFLAGS) -lm


################################################################################
## Created Counter test
prfx=Created_Counter

libCreated_Counter.so: $(prfx)/Lib_With_Created_Counter.c
	$(CC) -shared -Wall -fPIC $(CFLAGS) $(INCLUDE) -o lib/$@ $^

libCreated_Counter_static.a: $(prfx)/Lib_With_Created_Counter.c
	$(CC) -Bstatic -static -Wall $(CFLAGS) $(INCLUDE) -c -o lib/Lib_With_Created_Counter.o $^
	ar rs lib/$@ lib/Lib_With_Created_Counter.o
	rm lib/Lib_With_Created_Counter.o

Created_Counter_Test: $(prfx)/Created_Counter_Driver.c libCreated_Counter.so
	$(CC) $< -o $@ $(INCLUDE) $(CFLAGS) $(UTILOBJS) -lCreated_Counter $(LDFLAGS) -lm
Overflow_Test: $(prfx)/Overflow_Driver.c libCreated_Counter.so
	$(CC) $< -o $@ $(INCLUDE) $(CFLAGS) $(UTILOBJS) -lCreated_Counter $(LDFLAGS) -lm
Overflow_Static_Test: $(prfx)/Overflow_Driver.c libCreated_Counter_static.a
	$(CC) $< -o $@ $(INCLUDE) $(CFLAGS) $(UTILOBJS) lib/libCreated_Counter_static.a $(datadir)/libpapi.a $(datadir)/libsde.a -ldl -lrt

libCreated_Counter++.so: $(prfx)/Lib_With_Created_Counter++.cpp
	$(CXX) -shared -Wall -fPIC $(CXXFLAGS) $(INCLUDE) -o lib/$@ $^

Created_Counter_Test++: $(prfx)/Created_Counter_Driver++.cpp libCreated_Counter++.so
	$(CXX) $< -o $@ $(INCLUDE) $(CXXFLAGS) $(UTILOBJS) -lCreated_Counter++ $(LDFLAGS) -lm

################################################################################
## Counting Set test
prfx=Counting_Set

libCounting_Set++.so: $(prfx)/CountingSet_Lib++.cpp $(prfx)/cset_lib.hpp
	$(CXX) -shared -Wall -fPIC $(CXXFLAGS) $(INCLUDE) -o lib/$@ $<

Counting_Set_MemLeak_Test++: $(prfx)/MemoryLeak_CountingSet_Driver++.cpp libCounting_Set++.so
	$(CXX) $< -o $@ $(INCLUDE) $(CXXFLAGS) $(UTILOBJS) -lCounting_Set++ $(LDFLAGS)

Counting_Set_Simple_Test++: $(prfx)/Simple_CountingSet_Driver++.cpp libCounting_Set++.so
	$(CXX) $< -o $@ $(INCLUDE) $(CXXFLAGS) $(UTILOBJS) -lCounting_Set++ $(LDFLAGS)

libCounting_Set.so: $(prfx)/CountingSet_Lib.c
	$(CC) -shared -Wall -fPIC $(CFLAGS) $(INCLUDE) -o lib/$@ $^

Counting_Set_Simple_Test: $(prfx)/Simple_CountingSet_Driver.c libCounting_Set.so
	$(CC) $< -o $@ $(INCLUDE) $(CFLAGS) $(UTILOBJS) -lCounting_Set $(LDFLAGS)

Counting_Set_MemLeak_Test: $(prfx)/MemoryLeak_CountingSet_Driver.c libCounting_Set.so
	$(CC) $< -o $@ $(INCLUDE) $(CFLAGS) $(UTILOBJS) -lCounting_Set $(LDFLAGS)

################################################################################
## Advanced test
prfx=Advanced_C+FORTRAN
rcrd_prfx=Recorder

libXandria.so: $(prfx)/Xandria.F90 $(prfx)/sde_symbols.c
	$(CC) -shared -Wall -fPIC $(CFLAGS) $(INCLUDE) -c -o $(prfx)/sde_symbols.o $(prfx)/sde_symbols.c
	$(F77) -shared -Wall -fPIC $(FFLAGS) $(INCLUDE) -o lib/$@ $(SDE_F08_API) $(prfx)/sde_symbols.o $<

libGamum.so: $(prfx)/Gamum.c
	$(CC) -shared -Wall -fPIC $(CFLAGS) $(INCLUDE) -o lib/$@ $^

sde_test_f08: $(prfx)/sde_test_f08.F90 $(UTILOBJS) $(PAPILIB) libXandria.so libGamum.so libRecorder.so
	$(F77) $< -o $@ $(INCLUDE) $(FFLAGS) $(UTILOBJS) -lXandria -lGamum -lRecorder $(LDFLAGS)

################################################################################
## Cleaning

clean:
	rm -f *.o *.mod lib/*.so lib/*.a $(TESTS)

=== src/components/sysdetect/tests/Makefile ===
NAME=sysdetect

include ../../Makefile_comp_tests.target

%.o:%.c
	$(CC) $(CFLAGS) $(OPTFLAGS) $(INCLUDE) -c -o $@ $<

ifneq ($(MPICC),)
    ifeq ($(NO_MPI_TESTS),)
        MPITESTS = query_device_mpi
    else
        MPITESTS =
    endif
endif

ifneq ($(F77),)
    FTESTS = query_device_simple_f
else
    FTESTS =
endif

ifeq ($(notdir $(F77)),gfortran)
    FFLAGS +=-ffree-form -ffree-line-length-none
else ifeq ($(notdir $(F77)),flang)
    FFLAGS +=-ffree-form
else
    FFLAGS +=-free
endif

TESTS = query_device_simple \
        $(FTESTS)           \
        $(MPITESTS)

sysdetect_tests: $(TESTS)

query_device_simple: query_device_simple.o $(UTILOBJS) $(PAPILIB)
	$(CC) $(CFLAGS) $(INCLUDE) -o query_device_simple query_device_simple.o $(UTILOBJS) $(PAPILIB) $(LDFLAGS)

query_device_mpi: query_device_mpi.o $(UTILOBJS) $(PAPILIB)
	$(MPICC) $(CFLAGS) $(INCLUDE) -o query_device_mpi query_device_mpi.o $(UTILOBJS) $(PAPILIB) $(LDFLAGS)

query_device_mpi.o: query_device_mpi.c
	$(MPICC) $(CFLAGS) $(OPTFLAGS) $(INCLUDE) -c -o $@ $<

query_device_simple_f: query_device_simple_f.F
	$(F77) $(FFLAGS) -I../../.. -o $@ $< $(PAPILIB) $(LDFLAGS)

clean:
	rm -f $(TESTS) *.o

=== src/components/cuda/tests/BlackScholes/Makefile ===
################################################################################
#
# Copyright 1993-2015 NVIDIA Corporation.  All rights reserved.
#
# NOTICE TO USER:
#
# This source code is subject to NVIDIA ownership rights under U.S. and
# international Copyright laws.
#
# NVIDIA MAKES NO REPRESENTATION ABOUT THE SUITABILITY OF THIS SOURCE
# CODE FOR ANY PURPOSE.  IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR
# IMPLIED WARRANTY OF ANY KIND.  NVIDIA DISCLAIMS ALL WARRANTIES WITH
# REGARD TO THIS SOURCE CODE, INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY, NONINFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE.
# IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL,
# OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
# OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
# OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
# OR PERFORMANCE OF THIS SOURCE CODE.
#
# U.S. Government End Users.  This source code is a "commercial item" as
# that term is defined at 48 C.F.R. 2.101 (OCT 1995), consisting  of
# "commercial computer software" and "commercial computer software
# documentation" as such terms are used in 48 C.F.R. 12.212 (SEPT 1995)
# and is provided to the U.S. Government only as a commercial end item.
# Consistent with 48 C.F.R.12.212 and 48 C.F.R. 227.7202-1 through
# 227.7202-4 (JUNE 1995), all U.S. Government End Users acquire the
# source code with only those rights set forth herein.
#
################################################################################
#
# Makefile project only supported on Mac OS X and Linux Platforms)
#
################################################################################

# Location of the CUDA Toolkit
CUDA_PATH ?= ${CUDA_HOME}
NVCC = $(PAPI_CUDA_ROOT)/bin/nvcc 
NVCFLAGS = -g -ccbin='$(CC)' $(NVPPC64LEFLAGS)
INCLUDE  = -I$(PAPI_CUDA_ROOT)/include -I$(PAPI_CUPTI_ROOT)/include -I../../../../
CUDALIBS = -L$(PAPI_CUDA_ROOT)/lib64 -L$(PAPI_CUDA_ROOT)/lib64/stubs -L$(PAPI_CUPTI_ROOT)/lib64 -lcudart -lcupti -lcuda 
PAPISTATIC = ../../../../libpapi.a 
PAPILIB  = -L../../../../libpfm4/lib -lpfm
##############################
# start deprecated interface #
##############################
ifeq ($(x86_64),1)
    $(info WARNING - x86_64 variable has been deprecated)
    $(info WARNING - please use TARGET_ARCH=x86_64 instead)
    TARGET_ARCH ?= x86_64
endif
ifeq ($(ARMv7),1)
    $(info WARNING - ARMv7 variable has been deprecated)
    $(info WARNING - please use TARGET_ARCH=armv7l instead)
    TARGET_ARCH ?= armv7l
endif
ifeq ($(aarch64),1)
    $(info WARNING - aarch64 variable has been deprecated)
    $(info WARNING - please use TARGET_ARCH=aarch64 instead)
    TARGET_ARCH ?= aarch64
endif
ifeq ($(ppc64le),1)
    $(info WARNING - ppc64le variable has been deprecated)
    $(info WARNING - please use TARGET_ARCH=ppc64le instead)
    TARGET_ARCH ?= ppc64le
endif
ifneq ($(GCC),)
    $(info WARNING - GCC variable has been deprecated)
    $(info WARNING - please use HOST_COMPILER=$(GCC) instead)
    HOST_COMPILER ?= $(GCC)
endif
ifneq ($(abi),)
    $(error ERROR - abi variable has been removed)
endif
############################
# end deprecated interface #
############################

# architecture
HOST_ARCH   := $(shell uname -m)
TARGET_ARCH ?= $(HOST_ARCH)
ifneq (,$(filter $(TARGET_ARCH),x86_64 aarch64 ppc64le armv7l))
    ifneq ($(TARGET_ARCH),$(HOST_ARCH))
        ifneq (,$(filter $(TARGET_ARCH),x86_64 aarch64 ppc64le))
            TARGET_SIZE := 64
        else ifneq (,$(filter $(TARGET_ARCH),armv7l))
            TARGET_SIZE := 32
        endif
    else
        TARGET_SIZE := $(shell getconf LONG_BIT)
    endif
else
    $(error ERROR - unsupported value $(TARGET_ARCH) for TARGET_ARCH!)
endif
ifneq ($(TARGET_ARCH),$(HOST_ARCH))
    ifeq (,$(filter $(HOST_ARCH)-$(TARGET_ARCH),aarch64-armv7l x86_64-armv7l x86_64-aarch64 x86_64-ppc64le))
        $(error ERROR - cross compiling from $(HOST_ARCH) to $(TARGET_ARCH) is not supported!)
    endif
endif

# When on native aarch64 system with userspace of 32-bit, change TARGET_ARCH to armv7l
ifeq ($(HOST_ARCH)-$(TARGET_ARCH)-$(TARGET_SIZE),aarch64-aarch64-32)
    TARGET_ARCH = armv7l
endif

# operating system
HOST_OS   := $(shell uname -s 2>/dev/null | tr "[:upper:]" "[:lower:]")
TARGET_OS ?= $(HOST_OS)
ifeq (,$(filter $(TARGET_OS),linux darwin qnx android))
    $(error ERROR - unsupported value $(TARGET_OS) for TARGET_OS!)
endif

# host compiler
ifeq ($(TARGET_OS),darwin)
    ifeq ($(shell expr `xcodebuild -version | grep -i xcode | awk '{print $$2}' | cut -d'.' -f1` \>= 5),1)
        HOST_COMPILER ?= clang++
    endif
else ifneq ($(TARGET_ARCH),$(HOST_ARCH))
    ifeq ($(HOST_ARCH)-$(TARGET_ARCH),x86_64-armv7l)
        ifeq ($(TARGET_OS),linux)
            HOST_COMPILER ?= arm-linux-gnueabihf-g++
        else ifeq ($(TARGET_OS),qnx)
            ifeq ($(QNX_HOST),)
                $(error ERROR - QNX_HOST must be passed to the QNX host toolchain)
            endif
            ifeq ($(QNX_TARGET),)
                $(error ERROR - QNX_TARGET must be passed to the QNX target toolchain)
            endif
            export QNX_HOST
            export QNX_TARGET
            HOST_COMPILER ?= $(QNX_HOST)/usr/bin/arm-unknown-nto-qnx6.6.0eabi-g++
        else ifeq ($(TARGET_OS),android)
            HOST_COMPILER ?= arm-linux-androideabi-g++
        endif
    else ifeq ($(TARGET_ARCH),aarch64)
        ifeq ($(TARGET_OS), linux)
            HOST_COMPILER ?= aarch64-linux-gnu-g++
        else ifeq ($(TARGET_OS),qnx)
            ifeq ($(QNX_HOST),)
                $(error ERROR - QNX_HOST must be passed to the QNX host toolchain)
            endif
            ifeq ($(QNX_TARGET),)
                $(error ERROR - QNX_TARGET must be passed to the QNX target toolchain)
            endif
            export QNX_HOST
            export QNX_TARGET
            HOST_COMPILER ?= $(QNX_HOST)/usr/bin/aarch64-unknown-nto-qnx7.0.0-g++
        else ifeq ($(TARGET_OS), android)
            HOST_COMPILER ?= aarch64-linux-android-clang++
        endif
    else ifeq ($(TARGET_ARCH),ppc64le)
        HOST_COMPILER ?= powerpc64le-linux-gnu-g++
    endif
endif
HOST_COMPILER ?= g++
NVCC          := $(CUDA_PATH)/bin/nvcc -ccbin $(HOST_COMPILER)

# internal flags
NVCCFLAGS   := -m${TARGET_SIZE}
CCFLAGS     :=
LDFLAGS     :=

# build flags
ifeq ($(TARGET_OS),darwin)
    LDFLAGS += -rpath $(CUDA_PATH)/lib
    CCFLAGS += -arch $(HOST_ARCH)
else ifeq ($(HOST_ARCH)-$(TARGET_ARCH)-$(TARGET_OS),x86_64-armv7l-linux)
    LDFLAGS += --dynamic-linker=/lib/ld-linux-armhf.so.3
    CCFLAGS += -mfloat-abi=hard
else ifeq ($(TARGET_OS),android)
    LDFLAGS += -pie
    CCFLAGS += -fpie -fpic -fexceptions
endif

ifneq ($(TARGET_ARCH),$(HOST_ARCH))
    ifeq ($(TARGET_ARCH)-$(TARGET_OS),armv7l-linux)
        ifneq ($(TARGET_FS),)
            GCCVERSIONLTEQ46 := $(shell expr `$(HOST_COMPILER) -dumpversion` \<= 4.6)
            ifeq ($(GCCVERSIONLTEQ46),1)
                CCFLAGS += --sysroot=$(TARGET_FS)
            endif
            LDFLAGS += --sysroot=$(TARGET_FS)
            LDFLAGS += -rpath-link=$(TARGET_FS)/lib
            LDFLAGS += -rpath-link=$(TARGET_FS)/usr/lib
            LDFLAGS += -rpath-link=$(TARGET_FS)/usr/lib/arm-linux-gnueabihf
        endif
    endif
    ifeq ($(TARGET_ARCH)-$(TARGET_OS),aarch64-linux)
        ifneq ($(TARGET_FS),)
            GCCVERSIONLTEQ46 := $(shell expr `$(HOST_COMPILER) -dumpversion` \<= 4.6)
            ifeq ($(GCCVERSIONLTEQ46),1)
                CCFLAGS += --sysroot=$(TARGET_FS)
            endif
            LDFLAGS += --sysroot=$(TARGET_FS)
            LDFLAGS += -rpath-link=$(TARGET_FS)/lib -L $(TARGET_FS)/lib
            LDFLAGS += -rpath-link=$(TARGET_FS)/usr/lib -L $(TARGET_FS)/usr/lib
            LDFLAGS += -rpath-link=$(TARGET_FS)/usr/lib/aarch64-linux-gnu -L $(TARGET_FS)/usr/lib/aarch64-linux-gnu
            LDFLAGS += --unresolved-symbols=ignore-in-shared-libs
            CCFLAGS += -isystem=$(TARGET_FS)/usr/include
            CCFLAGS += -isystem=$(TARGET_FS)/usr/include/aarch64-linux-gnu
        endif
    endif
endif

ifeq ($(TARGET_OS),qnx)
    CCFLAGS += -DWIN_INTERFACE_CUSTOM
    LDFLAGS += -lsocket
endif

# Install directory of different arch
CUDA_INSTALL_TARGET_DIR :=
ifeq ($(TARGET_ARCH)-$(TARGET_OS),armv7l-linux)
    CUDA_INSTALL_TARGET_DIR = targets/armv7-linux-gnueabihf/
else ifeq ($(TARGET_ARCH)-$(TARGET_OS),aarch64-linux)
    CUDA_INSTALL_TARGET_DIR = targets/aarch64-linux/
else ifeq ($(TARGET_ARCH)-$(TARGET_OS),armv7l-android)
    CUDA_INSTALL_TARGET_DIR = targets/armv7-linux-androideabi/
else ifeq ($(TARGET_ARCH)-$(TARGET_OS),aarch64-android)
    CUDA_INSTALL_TARGET_DIR = targets/aarch64-linux-androideabi/
else ifeq ($(TARGET_ARCH)-$(TARGET_OS),armv7l-qnx)
    CUDA_INSTALL_TARGET_DIR = targets/ARMv7-linux-QNX/
else ifeq ($(TARGET_ARCH)-$(TARGET_OS),aarch64-qnx)
    CUDA_INSTALL_TARGET_DIR = targets/aarch64-qnx/
else ifeq ($(TARGET_ARCH),ppc64le)
    CUDA_INSTALL_TARGET_DIR = targets/ppc64le-linux/
endif

# Debug build flags
ifeq ($(dbg),1)
      NVCCFLAGS += -g -G
      BUILD_TYPE := debug
else
      BUILD_TYPE := release
endif

ALL_CCFLAGS :=
ALL_CCFLAGS += $(NVCCFLAGS)
ALL_CCFLAGS += $(EXTRA_NVCCFLAGS)
ALL_CCFLAGS += $(addprefix -Xcompiler ,$(CCFLAGS))
ALL_CCFLAGS += $(addprefix -Xcompiler ,$(EXTRA_CCFLAGS))

SAMPLE_ENABLED := 1

ALL_LDFLAGS :=
ALL_LDFLAGS += $(ALL_CCFLAGS)
ALL_LDFLAGS += $(addprefix -Xlinker ,$(LDFLAGS))
ALL_LDFLAGS += $(addprefix -Xlinker ,$(EXTRA_LDFLAGS))

# Common includes and paths for CUDA
INCLUDES  := -I../../common/inc -I${CUDA_PATH}/samples/common/inc
LIBRARIES :=

################################################################################

# Gencode arguments
SMS ?= 30 35 37 50 52 60 61 70 75
SMS=70

ifeq ($(SMS),)
$(info >>> WARNING - no SM architectures have been specified - waiving sample <<<)
SAMPLE_ENABLED := 0
endif

ifeq ($(GENCODE_FLAGS),)
# Generate SASS code for each SM architecture listed in $(SMS)
$(foreach sm,$(SMS),$(eval GENCODE_FLAGS += -gencode arch=compute_$(sm),code=sm_$(sm)))

# Generate PTX code from the highest SM architecture in $(SMS) to guarantee forward-compatibility
HIGHEST_SM := $(lastword $(sort $(SMS)))
ifneq ($(HIGHEST_SM),)
GENCODE_FLAGS += -gencode arch=compute_$(HIGHEST_SM),code=compute_$(HIGHEST_SM)
endif
endif

ALL_CCFLAGS += -maxrregcount=16

# The following three lines were necessary to call the _papi_hwi_lock() and unlock
# functions used in thr_BlackScholes.cu. These are linux specific; for a different
# OS, see how these are defined in the PAPI/src/config.log. LOCKFILES is used in
# the compilation thr_BlackScholes.o. 
OSLOCK = linux-lock.h
OSCONTEXT = linux-context.h
LOCKFILES = -DOSLOCK=\"$(OSLOCK)\" -DOSCONTEXT=\"$(OSCONTEXT)\"
ifeq ($(SAMPLE_ENABLED),0)
EXEC ?= @echo "[@]"
endif

################################################################################

# Target rules
all: build

build: BlackScholes

check.deps:
ifeq ($(SAMPLE_ENABLED),0)
	@echo "Sample will be waived due to the above missing dependencies"
else
	@echo "Sample is ready - all dependencies have been met"
endif

BlackScholes.o:BlackScholes.cu
	$(EXEC) $(NVCC) $(INCLUDES) $(ALL_CCFLAGS) $(GENCODE_FLAGS) $(INCLUDE) -o $@ -c $<

BlackScholes_gold.o:BlackScholes_gold.cpp
	$(EXEC) $(NVCC) $(INCLUDES) $(ALL_CCFLAGS) $(GENCODE_FLAGS) -o $@ -c $<

BlackScholes: BlackScholes.o BlackScholes_gold.o
	$(EXEC) $(NVCC) $(PAPISTATIC) $(ALL_LDFLAGS) $(GENCODE_FLAGS) -o $@ $+ $(PAPILIB) $(LIBRARIES) $(CUDALIBS) -lpthread
#$(EXEC) mkdir -p ../../bin/$(TARGET_ARCH)/$(TARGET_OS)/$(BUILD_TYPE)
#$(EXEC) cp $@ ../../bin/$(TARGET_ARCH)/$(TARGET_OS)/$(BUILD_TYPE)

thr_BlackScholes.o:thr_BlackScholes.cu
	$(EXEC) $(NVCC) $(INCLUDES) $(ALL_CCFLAGS) $(LOCKFILES) $(GENCODE_FLAGS) $(INCLUDE) -g -o $@ -c $<

thr_BlackScholes: thr_BlackScholes.o BlackScholes_gold.o
	$(EXEC) $(NVCC) $(PAPISTATIC) $(ALL_LDFLAGS) $(GENCODE_FLAGS) -g -o $@ $+ $(PAPILIB) $(LIBRARIES) $(CUDALIBS)

=== debian/changelog ===
papi (7.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Update upstream URLs.
  * Refresh patches.
  * Bump libpfm4-dev B-D to >= 4.12.1+git19.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 18 Aug 2023 09:02:38 +0200

=== debian/control ===
Source: papi
Section: devel
Priority: optional
Maintainer: Debian HPC Team <debian-hpc@lists.debian.org>
Uploaders:
 Vincent Danjean <vdanjean@debian.org>,
 Andreas Beckmann <anbe@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 gfortran,
 libpfm4-dev (>= 4.12.1+git19) [linux-any],
 librocm-smi-dev [!hppa !x32 !hurd-any !kfreebsd-any],
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://icl.utk.edu/papi/
Vcs-Browser: https://salsa.debian.org/hpc-team/papi
Vcs-Git: https://salsa.debian.org/hpc-team/papi.git

Package: libpapi7.0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends}, ${misc:Depends}
Description: PAPI runtime (shared libraries)
 Performance Application Programming Interface (PAPI) provides the tool
 designer and application engineer with a consistent interface and methodology
 for use of the performance counter hardware found in most major
 microprocessors. PAPI enables software engineers to see, in near real time,
 the relation between software performance and processor events.
 .
 In addition Component PAPI provides access to a collection of components that
 expose performance measurement opportunites across the hardware and software
 stack.
 .
 Accessing performance counters from userspace may require reducing the paranoia
 level in /proc/sys/kernel/perf_event_paranoid, see README.Debian for details.
 .
 This package provides the shared library.

Package: libsde1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends}, ${misc:Depends}
Description: PAPI software defined events runtime (shared libraries)
 Performance Application Programming Interface (PAPI) provides the tool
 designer and application engineer with a consistent interface and methodology
 for use of the performance counter hardware found in most major
 microprocessors. PAPI enables software engineers to see, in near real time,
 the relation between software performance and processor events.
 .
 Software Defined Events (SDEs) allow arbitrary custom performance metrics
 to be defined by applications or performance tools that can be measured by
 PAPI via the sde component.
 .
 This package provides the shared library.

Package: libpapi-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libpapi${papi:SOVERSION} (= ${binary:Version}),
 libsde1 (= ${binary:Version}),
 ${misc:Depends}
Description: PAPI development files (headers and API documentation)
 Performance Application Programming Interface (PAPI) provides the tool
 designer and application engineer with a consistent interface and methodology
 for use of the performance counter hardware found in most major
 microprocessors. PAPI enables software engineers to see, in near real time,
 the relation between software performance and processor events.
 .
 In addition Component PAPI provides access to a collection of components that
 expose performance measurement opportunites across the hardware and software
 stack.
 .
 This package provides the development files of PAPI.

Package: papi-tools
Architecture: any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${python3:Depends},
 ${shlibs:Depends}, ${misc:Depends}
Description: PAPI utilities
 Performance Application Programming Interface (PAPI) provides the tool
 designer and application engineer with a consistent interface and methodology
 for use of the performance counter hardware found in most major
 microprocessors. PAPI enables software engineers to see, in near real time,
 the relation between software performance and processor events.
 .
 In addition Component PAPI provides access to a collection of components that
 expose performance measurement opportunites across the hardware and software
 stack.
 .
 This package provides utilities provided by the PAPI software.

Package: papi-examples
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends:
 libpapi-dev (>= ${source:Version}),
 libpapi-dev (<< ${source:Upstream-Version}.~-~),
 ${misc:Depends}
Recommends:
 build-essential,
 gfortran,
 mpi-default-dev,
Description: PAPI example files and test programs
 Performance Application Programming Interface (PAPI) provides the tool
 designer and application engineer with a consistent interface and methodology
 for use of the performance counter hardware found in most major
 microprocessors. PAPI enables software engineers to see, in near real time,
 the relation between software performance and processor events.
 .
 In addition Component PAPI provides access to a collection of components that
 expose performance measurement opportunites across the hardware and software
 stack.
 .
 This package provides examples and tests of the PAPI software.
